diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index d8640e467..a73472626 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -2,13 +2,16 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.core.Global;
@@ -22,25 +25,17 @@ import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 import java.util.UUID;
 
-import static org.lwjgl.opengl.GL11.GL_COLOR_MATERIAL;
-import static org.lwjgl.opengl.GL11.GL_LIGHT0;
-import static org.lwjgl.opengl.GL11.GL_LIGHT1;
-import static org.lwjgl.opengl.GL11.GL_LIGHTING;
-
-public class MobRendererPlayer extends MobRendererBipedArmored<Player>
-{
+public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
 
 
     private BlocksContainer container = null;
 
-    public MobRendererPlayer()
-    {
+    public MobRendererPlayer() {
         super(0.5F);
     }
 
@@ -55,8 +50,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         }
     }
 
-    public void drawFirstPersonHand(final @NotNull Tessellator tessellator, final @NotNull Player player, final boolean isLeft)
-    {
+    public void drawFirstPersonHand(final @NotNull TessellatorGeneral tessellator, final @NotNull Player player, final boolean isLeft) {
         // TODO rework the transform nightmare that surround these method calls
         final StaticEntityModel activeModel = getActiveModel(player, true);
         activeModel.resetBones();
@@ -64,12 +58,12 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         activeModel.getTransform("leftSleeve").visible = player.playerConfig.sleeveLeftEnabled();
         activeModel.getTransform("rightSleeve").visible = player.playerConfig.sleeveRightEnabled();
 
-        if (isLeft){
+        if (isLeft) {
             activeModel.getTransform("rightArm").visible = false;
         } else {
             activeModel.getTransform("leftArm").visible = false;
         }
-        activeModel.render(tessellator);
+        activeModel.render();
     }
 
     public void drawHeldObject(final Player player, final float partialTick) {
@@ -78,31 +72,31 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                 this.container = new BlocksContainer(player.world);
             }
 
-            final Tessellator tessellator = Tessellator.instance;
-            final Minecraft mc = Minecraft.getMinecraft();
-            TextureRegistry.blockAtlas.bind();
-            GL11.glPushMatrix();
+            final TessellatorGeneral tessellator = GLRenderer.getTessellator();
+            TextureRegistry.worldAtlas.bind();
+            GLRenderer.pushFrame();
             Lighting.disable();
 
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glDisable(GL11.GL_CULL_FACE);
-            if(mc.isAmbientOcclusionEnabled()) {
-                GL11.glShadeModel(GL11.GL_SMOOTH);
-            } else {
-                GL11.glShadeModel(GL11.GL_FLAT);
-            }
-            GL11.glScalef(0.55f, -0.55f, 0.55f);
-            GL11.glTranslatef(0, -0.75f, -0.75f);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.disableState(State.CULL_FACE);
+//            if (mc.isAmbientOcclusionEnabled()) {
+//                GL11.glShadeModel(GL11.GL_SMOOTH);
+//            } else {
+//                GL11.glShadeModel(GL11.GL_FLAT);
+//            }
+            GLRenderer.modelM4f().scale(0.55f, -0.55f, 0.55f);
+            GLRenderer.modelM4f().translate(0, -0.75f, -0.75f);
 
             final TilePos blockPos = new TilePos(player.x, player.y + 1, player.z);
 
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(-blockPos.x -0.5, -blockPos.y -0.5, -blockPos.z -0.5);
+            tessellator.setTranslation(-blockPos.x - 0.5, -blockPos.y - 0.5, -blockPos.z - 0.5);
 
             this.container.setLightReferenceEntity(player);
+            this.container.partialTick = partialTick;
             this.container.setBlock(blockPos.x, blockPos.y, blockPos.z, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
-            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, this.container, blockPos);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(GLRenderer.getTessellator(), this.container, blockPos);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
             this.container.setLightReferenceEntity(null);
@@ -115,71 +109,66 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                 carriedBlock.entity.worldObj = null;
             }
 
-            GL11.glPopMatrix();
-            GL11.glEnable(GL_LIGHTING);
-            GL11.glEnable(GL_LIGHT0);
-            GL11.glEnable(GL_LIGHT1);
-            GL11.glEnable(GL_COLOR_MATERIAL);
+            GLRenderer.popFrame();
+//            GL11.glEnable(GL_LIGHTING);
+//            GL11.glEnable(GL_LIGHT0);
+//            GL11.glEnable(GL_LIGHT1);
+//            GL11.glEnable(GL_COLOR_MATERIAL);
         }
     }
+
     @Override
-    protected void renderSpecials(final @NotNull Tessellator t, final @NotNull Player entity, final double x, final double y, final double z)
-    {
+    protected void renderSpecials(final @NotNull TessellatorGeneral t, final @NotNull Player entity, final double x, final double y, final double z) {
         if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
             return;
         }
-        if(Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && this.renderDispatcher.camera != null) // Render name
+        if (Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && this.renderDispatcher.camera != null) // Render name
         {
-            if (this.renderDispatcher.camera instanceof EntityCamera && ((EntityCamera) this.renderDispatcher.camera).mob == entity)
-            {
+            if (this.renderDispatcher.camera instanceof EntityCamera && ((EntityCamera) this.renderDispatcher.camera).mob == entity) {
                 return;
             }
             final float f = 1.6F;
             final float f1 = 0.01666667F * f;
             final float f2 = (float) this.renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
             final float f3 = entity.isSneaking() ? 32F : 64F;
-            if(f2 < f3)
-            {
+            if (f2 < f3) {
                 final String s = entity.getDisplayName();
-                if(!entity.isSneaking())
-                {
-                    if(entity.isPlayerSleeping())
-                    {
+                if (!entity.isSneaking()) {
+                    if (entity.isPlayerSleeping()) {
                         renderLivingLabel(t, entity, s, x, y - 1.5D, z, 64, false);
-                    } else
-                    {
+                    } else {
                         renderLivingLabel(t, entity, s, x, y, z, 64, false);
                     }
-                } else
-                {
+                } else {
                     final FontRenderer font = getFont();
-                    GL11.glPushMatrix();
-                    GL11.glTranslatef((float) x + 0.0F, (float) y + 2.3F, (float) z);
-                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(this.renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
-                    GL11.glScalef(-f1, -f1, f1);
-                    GL11.glDisable(GL11.GL_LIGHTING);
-                    GL11.glTranslatef(0.0F, 0.25F / f1, 0.0F);
-                    GL11.glDepthMask(false);
-                    GL11.glEnable(GL11.GL_BLEND);
-                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                    GL11.glDisable(GL11.GL_TEXTURE_2D);
+                    GLRenderer.pushFrame();
+                    GLRenderer.modelM4f().translate((float) x + 0.0F, (float) y + 2.3F, (float) z);
+//                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
+                    GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-this.renderDispatcher.viewLerpYaw));
+                    GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(this.renderDispatcher.viewLerpPitch));
+                    GLRenderer.modelM4f().scale(-f1, -f1, f1);
+                    GLRenderer.globalSetLightEnabled(false);
+                    GLRenderer.modelM4f().translate(0.0F, 0.25F / f1, 0.0F);
+                    GLRenderer.setDepthMask(false);
+                    GLRenderer.enableState(State.BLEND);
+                    GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+                    GLRenderer.pushFrame();
+                    GLRenderer.setShader(Shaders.COLOR);
                     t.startDrawingQuads();
                     final int halfWidth = font.stringWidth(s) / 2;
-                    t.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+                    t.setColor4f(0.0F, 0.0F, 0.0F, 0.25F);
                     t.addVertex(-halfWidth - 1, -1D, 0.0D);
                     t.addVertex(-halfWidth - 1, 8D, 0.0D);
                     t.addVertex(halfWidth + 1, 8D, 0.0D);
                     t.addVertex(halfWidth + 1, -1D, 0.0D);
                     t.draw();
-                    GL11.glEnable(GL11.GL_TEXTURE_2D);
-                    GL11.glDepthMask(true);
-                    font.renderCentered(t, s, 0, 0).setColor(0x20ffffff).call();
-                    GL11.glEnable(GL11.GL_LIGHTING);
-                    GL11.glDisable(GL11.GL_BLEND);
-                    GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-                    GL11.glPopMatrix();
+                    GLRenderer.popFrame();
+                    GLRenderer.setDepthMask(true);
+                    font.renderCentered(s, 0, 0).setColor(0x20ffffff).call();
+                    GLRenderer.globalSetLightEnabled(true);
+                    GLRenderer.disableState(State.BLEND);
+                    GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+                    GLRenderer.popFrame();
                 }
             }
         }
@@ -187,83 +176,80 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
 
     @Override
     protected void preRenderTransform(@NotNull final Player entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glTranslated(x, y, z);
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
 
-        if(entity.isAlive() && (entity.isPlayerSleeping())) {
-            GL11.glTranslatef(entity.sleepOffX, entity.sleepOffY, entity.sleepOffZ);
+        if (entity.isAlive() && (entity.isPlayerSleeping())) {
+            GLRenderer.modelM4f().translate(entity.sleepOffX, entity.sleepOffY, entity.sleepOffZ);
 
-            GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
-            GL11.glTranslatef(0, -4.5f, 0);
+            GLRenderer.modelM4f().scale(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
+            GLRenderer.modelM4f().translate(0, -4.5f, 0);
 
-            GL11.glRotatef(-entity.getBedOrientationInDegrees(), 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(270F, 0.0F, 1.0F, 0.0F);
+            GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-entity.getBedOrientationInDegrees()));
+            GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(getMaxDeathRotation(entity)));
+            GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(270F));
 
         } else {
-            GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
-            GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
+            GLRenderer.modelM4f().rotateY(-getBodyYaw(entity, partialTick));
+            GLRenderer.modelM4f().scale(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
         }
 
-        if(entity.deathTime > 0) {
+        if (entity.deathTime > 0) {
             float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
             rotationProgress = MathHelper.sqrt_float(rotationProgress);
-            if(rotationProgress > 1.0F) {
+            if (rotationProgress > 1.0F) {
                 rotationProgress = 1.0F;
             }
-            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+            GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(rotationProgress * getMaxDeathRotation(entity)));
         }
 
 
         final float scale = 0.9375F;
-        GL11.glScalef(scale, scale, scale);
+        GLRenderer.modelM4f().scale(scale, scale, scale);
 
         if (entity.isDwarf()) {
-            GL11.glScalef(0.6f, 0.5f, 0.6f);
+            GLRenderer.modelM4f().scale(0.6f, 0.5f, 0.6f);
         }
 
         if (Specials.getSpecialsForPlayer(entity) == Specials.MELON || Specials.getSpecialsForPlayer(entity) == Specials.WATERMELON) {
-            GL11.glScalef(0.9f, 0.9f, 0.9f);
+            GLRenderer.modelM4f().scale(0.9f, 0.9f, 0.9f);
         }
 
 
     }
 
     @Override
-    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull Player player, final float partialTick)
-    {
+    protected void renderAdditional(@NotNull final TessellatorGeneral tessellator, final @NotNull Player player, final float partialTick) {
         final StaticEntityModel activeModel = getActiveModel(player, false);
 
         super.renderAdditional(tessellator, player, partialTick);
 
         if (player.playerConfig.capeEnabled()) {
             boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
-            if (!renderCape)
-            {
+            if (!renderCape) {
                 renderCape = bindDownloadableTexture(player.capeURL, null, null);
             }
 
-            if(renderCape) {
-                GL11.glPushMatrix();
-                final float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
-                GL11.glColor4f(brightness, brightness, brightness, 1f);
-                GL11.glTranslatef(0.0F, 0.0F, 0.125F);
+            if (renderCape) {
+                GLRenderer.pushFrame();
+                GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+                GLRenderer.modelM4f().translate(0.0F, 0.0F, 0.125F);
                 final float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
                 final float bodyAngle = 5;
                 final double xd = MathHelper.lerp(player.xdO, player.xd, partialTick);
                 final double yd = Math.min(MathHelper.lerp(player.ydO, player.yd, partialTick), 0);
                 final double zd = MathHelper.lerp(player.zdO, player.zd, partialTick);
-                final double vel = -1/(3 * Math.hypot(xd, zd) + 1) + 1;
+                final double vel = -1 / (3 * Math.hypot(xd, zd) + 1) + 1;
                 final double moveAng = Math.atan2(xd, zd);
                 final double yawRad = Math.toRadians(yawOff);
-                final double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
-                player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
+                final double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2) / 2) - 1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
+                player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick) / (30 - 29 * MathHelper.clamp(vel, 0, 1)));
                 player.lastRenderTick = player.tickCount;
                 final double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
                 activeModel.translateToBone("cape");
                 final StaticEntityModel cape = getModel("cape");
                 cape.getTransform("cape").rotX = -MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - yd * 60, 0, 180) * MathHelper.DEG_TO_RAD;
-                cape.render(tessellator);
-                GL11.glPopMatrix();
+                cape.render();
+                GLRenderer.popFrame();
             }
         }
 
@@ -272,12 +258,12 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
             final float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
             final float swingProgress = player.getSwingProgress(partialTick);
             final float swing = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * -2.0F) * 0.4F;
-            GL11.glTranslatef(0, (MathHelper.cos(walkProgress/2 * 2/3f + MathHelper.PI)/12f * walkSpeed + 0.1f - swing/4f) * ENTITY_RENDER_SCALE, 0);
-            GL11.glTranslatef(0, 1.25f * ENTITY_RENDER_SCALE, 0);
+            GLRenderer.modelM4f().translate(0, (MathHelper.cos(walkProgress / 2 * 2 / 3f + MathHelper.PI) / 12f * walkSpeed + 0.1f - swing / 4f) * ENTITY_RENDER_SCALE, 0);
+            GLRenderer.modelM4f().translate(0, 1.25f * ENTITY_RENDER_SCALE, 0);
             if (player.isSneaking()) {
-                GL11.glTranslatef(0, 0, 4);
+                GLRenderer.modelM4f().translate(0, 0, 4);
             }
-            GL11.glScalef(-ENTITY_RENDER_SCALE, -ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
+            GLRenderer.modelM4f().scale(-ENTITY_RENDER_SCALE, -ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
             drawHeldObject(player, partialTick);
         }
     }
@@ -341,7 +327,8 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         }
 
         public static @Nullable Specials getSpecialsForPlayer(final @NotNull Player player) {
-            if (!Minecraft.getMinecraft().gameSettings.devModels.value || !player.playerConfig.devModelEnabled()) return null;
+            if (!Minecraft.getMinecraft().gameSettings.devModels.value || !player.playerConfig.devModelEnabled())
+                return null;
             if (player.uuid.equals(SHIGN.uuid) || player.username.equals(SHIGN.username)) return SHIGN;
             if (player.uuid.equals(COOKIE.uuid) || player.username.equals(COOKIE.username)) return COOKIE;
             if (player.uuid.equals(THA_BOAR.uuid) || player.username.equals(THA_BOAR.username)) return THA_BOAR;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
index a10ef2547..fa28ac2ce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.animal.MobSheep;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -20,7 +20,7 @@ public class MobRendererSheep extends MobRenderer<MobSheep> {
         switch (layer) {
             case 1:
                 final int colorIndex = entity.getFleeceColor().blockMeta;
-                GL11.glColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][0], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][1], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][2]);
+                GLRenderer.setColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][0], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][1], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][2]);
                 model = getModel("main");
                 bindTexture("/assets/minecraft/textures/entity/sheep/wool_overlay.png");
                 break;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
index 7276fbd6a..e493129a8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.monster.MobSlime;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererSlime extends MobRenderer<MobSlime>
-{
+public class MobRendererSlime extends MobRenderer<MobSlime> {
 
     public MobRendererSlime(final float shadowSize) {
         super(shadowSize);
@@ -19,9 +19,9 @@ public class MobRendererSlime extends MobRenderer<MobSlime>
     @Override
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSlime entity, final float brightness, final float partialTick, final int layer) {
         final StaticEntityModel model = getModel("main");
-        GL11.glEnable(GL12.GL_NORMALIZE);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+//        GL11.glEnable(GL12.GL_NORMALIZE);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
         model.resetBones();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
index 27c354d3b..fb07dd858 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
@@ -1,6 +1,9 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -19,15 +22,10 @@ public class MobRendererSpider extends MobRenderer<MobSpider> {
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSpider entity, final float brightness, final float partialTick, final int layer) {
         if (layer == 1) {
             bindTexture("/assets/minecraft/textures/entity/spider/eyes/" + entity.getTextureReference() + ".png");
-            if(LightmapHelper.isLightmapEnabled()) LightmapHelper.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(15));
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, (1.0F - entity.getBrightness(partialTick)) * 0.5F);
-        } else if (layer == 2) {
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
-            return null;
+            GLRenderer.setLightmapCoord1i(LightmapHelper.getOverbrightLightmapCoord(15));
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, (1.0F - entity.getBrightness(partialTick)) * 0.5F);
         }
 
         final StaticEntityModel model = getModel("main");
@@ -55,22 +53,22 @@ public class MobRendererSpider extends MobRenderer<MobSpider> {
 
         final double rZ = 45 * MathHelper.DEG_TO_RAD;
         leg0.rotZ = -rZ;
-        leg1.rotZ =  rZ;
+        leg1.rotZ = rZ;
         leg2.rotZ = -rZ * 0.74F;
-        leg3.rotZ =  rZ * 0.74F;
+        leg3.rotZ = rZ * 0.74F;
         leg4.rotZ = -rZ * 0.74F;
-        leg5.rotZ =  rZ * 0.74F;
+        leg5.rotZ = rZ * 0.74F;
         leg6.rotZ = -rZ;
-        leg7.rotZ =  rZ;
+        leg7.rotZ = rZ;
         final double ry = 22.5 * MathHelper.DEG_TO_RAD;
-        leg0.rotY =  ry * 2.0F;
+        leg0.rotY = ry * 2.0F;
         leg1.rotY = -ry * 2.0F;
-        leg2.rotY =  ry;
+        leg2.rotY = ry;
         leg3.rotY = -ry;
         leg4.rotY = -ry;
-        leg5.rotY =  ry;
+        leg5.rotY = ry;
         leg6.rotY = -ry * 2.0;
-        leg7.rotY =  ry * 2.0F;
+        leg7.rotY = ry * 2.0F;
         final double pair1Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 0.0F) * 0.4F) * limbYaw;
         final double pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI) * 0.4F) * limbYaw;
         final double pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
@@ -105,6 +103,6 @@ public class MobRendererSpider extends MobRenderer<MobSpider> {
 
     @Override
     protected int maxRenderLayer(@NotNull final MobSpider entity) {
-        return 2;
+        return 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
index ddd6858d4..87a2d73b9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
@@ -1,11 +1,12 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobSquid;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
+import org.joml.Math;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class MobRendererSquid extends MobRenderer<MobSquid> {
@@ -33,32 +34,31 @@ public class MobRendererSquid extends MobRenderer<MobSquid> {
     }
 
     @Override
-    protected float getLimbPitch(final @NotNull MobSquid squid, final float partialTick)
-    {
+    protected float getLimbPitch(final @NotNull MobSquid squid, final float partialTick) {
         return MathHelper.lerp(squid.oldTentacleAngle, squid.tentacleAngle, partialTick);
     }
 
     @Override
     protected void preRenderTransform(@NotNull final MobSquid entity, final double x, final double y, final double z, final float _yaw, final float partialTick) {
         if (entity.isSpecial()) {
-            GL11.glTranslated(0, 1.5, 0);
+            GLRenderer.modelM4f().translate(0, 1.5f, 0);
             super.preRenderTransform(entity, x, y, z, _yaw, partialTick);
         } else {
-            GL11.glTranslated(x, y + 0.5, z);
-            GL11.glScalef(1/ MobRenderer.ENTITY_RENDER_SCALE, 1/ MobRenderer.ENTITY_RENDER_SCALE, 1/ MobRenderer.ENTITY_RENDER_SCALE);
+            GLRenderer.modelM4f().translate((float) x, (float) (y + 0.5), (float) z);
+            GLRenderer.modelM4f().scale(1 / MobRenderer.ENTITY_RENDER_SCALE, 1 / MobRenderer.ENTITY_RENDER_SCALE, 1 / MobRenderer.ENTITY_RENDER_SCALE);
             final float pitch = entity.xBodyRotO + (entity.xBodyRot - entity.xBodyRotO) * partialTick;
             final float yaw = entity.zBodyRotO + (entity.zBodyRot - entity.zBodyRotO) * partialTick;
-            GL11.glRotatef(180 - getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(pitch, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
+            GLRenderer.modelM4f().rotateY(Math.PI_f - getBodyYaw(entity, partialTick));
+            GLRenderer.modelM4f().rotateX(Math.toRadians(pitch));
+            GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
         }
     }
 
     @Override
-    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobSquid squid, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glTranslatef(0.0f, 1.25f, 0.0f);
-        super.renderPreview(tessellator,squid, x, y, z, yaw, partialTick);
-        GL11.glPopMatrix();
+    public void renderPreview(@NotNull final TessellatorGeneral tessellator, @NotNull final MobSquid squid, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(0.0f, 1.25f, 0.0f);
+        super.renderPreview(tessellator, squid, x, y, z, yaw, partialTick);
+        GLRenderer.popFrame();
     }
 }
